searchNodes=[{"doc":"Control GPIOs from ElixirIf you're coming from Elixir/ALE, check out our porting guide.Circuits.GPIO works great with LEDs, buttons, many kinds of sensors, and simple control of motors. In general, if a device requires high speed transactions or has hard real-time constraints in its interactions, this is not the right library. For those devices, see if there's a Linux kernel driver.","ref":"Circuits.GPIO.html","title":"Circuits.GPIO","type":"module"},{"doc":"Release the resources associated with the GPIO.This is optional. The garbage collector will free GPIO resources that aren't in use, but this will free them sooner.","ref":"Circuits.GPIO.html#close/1","title":"Circuits.GPIO.close/1","type":"function"},{"doc":"Return info about the low level GPIO interfaceThis may be helpful when debugging issues.","ref":"Circuits.GPIO.html#info/0","title":"Circuits.GPIO.info/0","type":"function"},{"doc":"Open a GPIO for use.pin should be a valid GPIO pin number on the system and pin_direction should be :input or :output. If opening as an output, then be sure to set the :initial_value option if you need the set to be glitch free.Options::initial_value - Set to :not_set, 0 or 1 if this is an output. :not_set is the default.:pull_mode - Set to :not_set, :pullup, :pulldown, or :none for an input pin. :not_set is the default.","ref":"Circuits.GPIO.html#open/3","title":"Circuits.GPIO.open/3","type":"function"},{"doc":"Get the GPIO pin number","ref":"Circuits.GPIO.html#pin/1","title":"Circuits.GPIO.pin/1","type":"function"},{"doc":"Read the current value on a pin.","ref":"Circuits.GPIO.html#read/1","title":"Circuits.GPIO.read/1","type":"function"},{"doc":"Change the direction of the pin.","ref":"Circuits.GPIO.html#set_direction/2","title":"Circuits.GPIO.set_direction/2","type":"function"},{"doc":"Enable or disable pin value change notifications. The notifications are sent based on the trigger parameter::none - No notifications are sent:rising - Send a notification when the pin changes from 0 to 1:falling - Send a notification when the pin changes from 1 to 0:both - Send a notification on all changesAvailable Options:suppress_glitches - It is possible that the pin transitions to a value and back by the time that Circuits GPIO gets to process it. This controls whether a notification is sent. Set this to false to receive notifications.receiver - Process which should receive the notifications. Defaults to the calling process (self())Notifications look like:{:circuits_gpio, pin_number, timestamp, value}Where pin_number is the pin that changed values, timestamp is roughly when the transition occurred in nanoseconds since host system boot time, and value is the new value.NOTE: You will need to store the Circuits.GPIO reference somewhere (like your GenServer's state) so that it doesn't get garbage collected. Event messages stop when it gets collected. If you only get one message and you are expecting more, this is likely the case.","ref":"Circuits.GPIO.html#set_interrupts/3","title":"Circuits.GPIO.set_interrupts/3","type":"function"},{"doc":"Enable or disable internal pull-up or pull-down resistor to GPIO pin","ref":"Circuits.GPIO.html#set_pull_mode/2","title":"Circuits.GPIO.set_pull_mode/2","type":"function"},{"doc":"Set the value of a pin. The pin should be configured to an output for this to work.","ref":"Circuits.GPIO.html#write/2","title":"Circuits.GPIO.write/2","type":"function"},{"doc":"Options for open/3","ref":"Circuits.GPIO.html#t:open_option/0","title":"Circuits.GPIO.open_option/0","type":"type"},{"doc":"The GPIO direction (input or output)","ref":"Circuits.GPIO.html#t:pin_direction/0","title":"Circuits.GPIO.pin_direction/0","type":"type"},{"doc":"A GPIO pin number. See your device's documentation for how these connect to wires","ref":"Circuits.GPIO.html#t:pin_number/0","title":"Circuits.GPIO.pin_number/0","type":"type"},{"doc":"Pull mode for platforms that support controllable pullups and pulldowns","ref":"Circuits.GPIO.html#t:pull_mode/0","title":"Circuits.GPIO.pull_mode/0","type":"type"},{"doc":"Trigger edge for pin change notifications","ref":"Circuits.GPIO.html#t:trigger/0","title":"Circuits.GPIO.trigger/0","type":"type"},{"doc":"GPIO logic value (low = 0 or high = 1)","ref":"Circuits.GPIO.html#t:value/0","title":"Circuits.GPIO.value/0","type":"type"},{"doc":"Erlang interface to Circuits.GPIOExample Erlang code: circuits_gpio:open(5, output)","ref":"circuits_gpio.html","title":"circuits_gpio","type":"module"},{"doc":"See Circuits.GPIO.open/2.","ref":"circuits_gpio.html#open/2","title":"circuits_gpio.open/2","type":"function"},{"doc":"See Circuits.GPIO.pin/1.","ref":"circuits_gpio.html#pin/1","title":"circuits_gpio.pin/1","type":"function"},{"doc":"See Circuits.GPIO.read/1.","ref":"circuits_gpio.html#read/1","title":"circuits_gpio.read/1","type":"function"},{"doc":"See Circuits.GPIO.set_direction/2.","ref":"circuits_gpio.html#set_direction/2","title":"circuits_gpio.set_direction/2","type":"function"},{"doc":"See Circuits.GPIO.set_interrupts/2.","ref":"circuits_gpio.html#set_interrupts/2","title":"circuits_gpio.set_interrupts/2","type":"function"},{"doc":"See Circuits.GPIO.set_interrupts/3.","ref":"circuits_gpio.html#set_interrupts/3","title":"circuits_gpio.set_interrupts/3","type":"function"},{"doc":"See Circuits.GPIO.set_pull_mode/2.","ref":"circuits_gpio.html#set_pull_mode/2","title":"circuits_gpio.set_pull_mode/2","type":"function"},{"doc":"See Circuits.GPIO.write/2.","ref":"circuits_gpio.html#write/2","title":"circuits_gpio.write/2","type":"function"},{"doc":"Elixir Circuits - GPIO Circuits.GPIO lets you control or read from GPIOs on Nerves or other Linux-based devices.If you're coming from Elixir/ALE, check out our porting guide.Circuits.GPIO works great with LEDs, buttons, many kinds of sensors, and simple control of motors. In general, if a device requires high speed transactions or has hard real-time constraints in its interactions, this is not the right library. For those devices, see if there's a Linux kernel driver.","ref":"readme.html","title":"Elixir Circuits - GPIO","type":"extras"},{"doc":"If you're natively compiling circuits_gpio on a Raspberry Pi or using Nerves, everything should work like any other Elixir library. Normally, you would include circuits_gpio as a dependency in your mix.exs like this:def deps do [{:circuits_gpio, &quot;~&gt; 0.4&quot;}] endOne common error on Raspbian is that the Erlang headers are missing (ie.h), you may need to install erlang with apt-get install erlang-dev or build Erlang from source per instructions here.","ref":"readme.html#getting-started","title":"Elixir Circuits - GPIO - Getting started","type":"extras"},{"doc":"Circuits.GPIO only supports simple uses of the GPIO interface in Linux, but you can still do quite a bit. The following examples were tested on a Raspberry Pi that was connected to an Erlang Embedded Demo Board. There's nothing special about either the demo board or the Raspberry Pi, so these should work similarly on other embedded Linux platforms.","ref":"readme.html#examples","title":"Elixir Circuits - GPIO - Examples","type":"extras"},{"doc":"A General Purpose Input/Output (GPIO) is just a wire that you can use as an input or an output. It can only be one of two values, 0 or 1. A 1 corresponds to a logic high voltage like 3.3 V and a 0 corresponds to 0 V. The actual voltage depends on the hardware.Here's an example of turning an LED on or off:To turn on the LED that's connected to the net (or wire) labeled GPIO18, run the following:iex&gt; {:ok, gpio} = Circuits.GPIO.open(18, :output) {:ok, #Reference&lt;...&gt;} iex&gt; Circuits.GPIO.write(gpio, 1) :ok iex&gt; Circuits.GPIO.close(gpio) :okNote that the call to Circuits.GPIO.close/1 is not necessary, as the garbage collector will free up any unreferenced GPIOs. It can be used to explicitly de-allocate connections you know you will not need anymore.Input works similarly. Here's an example of a button with a pull down resistor connected.If you're not familiar with pull up or pull down resistors, they're resistors whose purpose is to drive a wire high or low when the button isn't pressed. In this case, it drives the wire low. Many processors have ways of configuring internal resistors to accomplish the same effect without needing to add an external resistor. If you're using a Raspberry Pi, you can use the built-in pull-up/pull-down resistors.The code looks like this in Circuits.GPIO:iex&gt; {:ok, gpio} = Circuits.GPIO.open(17, :input) {:ok, #Reference&lt;...&gt;} iex&gt; Circuits.GPIO.read(gpio) 0 # Push the button down iex&gt; Circuits.GPIO.read(gpio) 1If you'd like to get a message when the button is pressed or released, call the set_interrupts function. You can trigger on the :rising edge, :falling edge or :both.iex&gt; Circuits.GPIO.set_interrupts(gpio, :both) :ok iex&gt; flush {:circuits_gpio, 17, 1233456, 1} {:circuits_gpio, 17, 1234567, 0} :okNote that after calling set_interrupts, the calling process will receive an initial message with the state of the pin. This prevents the race condition between getting the initial state of the pin and turning on interrupts. Without it, you could get the state of the pin, it could change states, and then you could start waiting on it for interrupts. If that happened, you would be out of sync.Internal pull-up/pull-downTo connect or disconnect an internal pull-up or pull-down resistor to a GPIO pin, call the set_pull_mode function.iex&gt; Circuits.GPIO.set_pull_mode(gpio, pull_mode) :okValid pull_mode values are :none :pullup, or :pulldownNote that set_pull_mode is platform dependent, and currently only works for Raspberry Pi hardware. Calls to set_pull_mode on other platforms will have no effect. The internal pull-up resistor value is between 50K and 65K, and the pull-down is between 50K and 60K. It is not possible to read back the current Pull-up/down settings, and GPIO pull-up pull-down resistor connections are maintained, even when the CPU is powered down.To get the GPIO pin number for a gpio reference, call the pin function.iex&gt; Circuits.GPIO.pin(gpio) 17","ref":"readme.html#gpio","title":"Elixir Circuits - GPIO - GPIO","type":"extras"},{"doc":"Circuits.GPIO supports a &quot;stub&quot; hardware abstraction layer on platforms without GPIO support and when MIX_ENV=test. The stub allows for some limited unit testing without real hardware.To use it, first check that you're using the &quot;stub&quot; HAL:iex&gt; Circuits.GPIO.info %{name: :stub, pins_open: 0}The stub HAL has 64 GPIOs. Each pair of GPIOs is connected. For example, GPIO 0 is connected to GPIO 1. If you open GPIO 0 as an output and GPIO 1 as an input, you can write to GPIO 0 and see the result on GPIO 1. Here's an example:iex&gt; {:ok, gpio0} = Circuits.GPIO.open(0, :output) {:ok, #Reference&lt;0.801050056.3201171470.249048&gt;} iex&gt; {:ok, gpio1} = Circuits.GPIO.open(1, :input) {:ok, #Reference&lt;0.801050056.3201171470.249052&gt;} iex&gt; Circuits.GPIO.read(gpio1) 0 iex&gt; Circuits.GPIO.write(gpio0, 1) :ok iex&gt; Circuits.GPIO.read(gpio1) 1The stub HAL is fairly limited, but it does support interrupts.If Circuits.GPIO is used as a dependency the stub may not be present. To manually enable it, set CIRCUITS_MIX_ENV to test and rebuild circuits_gpio.","ref":"readme.html#testing","title":"Elixir Circuits - GPIO - Testing","type":"extras"},{"doc":"How does Circuits.GPIO compare to Elixir/ALE?Circuits.GPIO is almost Elixir/ALE 2.0. The API for Elixir/ALE became difficult to change so we started again with Circuits.GPIO. The main improvements are:Improved performance and lower resource usageTimestamps on interruptsA hardware abstraction layer to support multiple ways of interfacing with the low level GPIO interfacesSee the Porting Guide for more information if you're an Elixir/ALE user.Where can I get help?Most issues people have are on how to communicate with hardware for the first time. Since Circuits.GPIO is a thin wrapper on the Linux sys class interface, you may find help by searching for similar issues when using Python or C.For help specifically with Circuits.GPIO, you may also find help on the nerves channel on the elixir-lang Slack. Many Nerves users also use Circuits.GPIO.I tried turning on and off a GPIO as fast as I could. Why was it slow?Please don't do that - there are so many better ways of accomplishing whatever you're trying to do:If you're trying to drive a servo or dim an LED, look into PWM. Many platforms have PWM hardware and you won't tax your CPU at all. If your platform is missing a PWM, several chips are available that take I2C commands to drive a PWM output.If you need to implement a wire level protocol to talk to a device, look for a Linux kernel driver. It may just be a matter of loading the right kernel module.If you want a blinking LED to indicate status, gpio really should be fast enough to do that, but check out Linux's LED class interface. Linux can flash LEDs, trigger off events and more. See nerves_leds.If you're still intent on optimizing GPIO access, you may be interested in gpio_twiddler.Can I develop code that uses GPIO on my laptop?See whether the &quot;stub&quot; HAL (described above) works for you or could be improved to support your use case.The following advice from Elixir/ALE may also be useful: You'll need to fake out the hardware. Code to do this depends on what your hardware actually does, but here's one example:Compiling and testing Elixir Nerves on your host machineHow do I call Circuits.GPIO from Erlang?Circuits.GPIO provides an Erlang-friendly binding to simplify calls from Erlang code. Instead of prefixing calls with: 'Elixir.Circuits.GPIO': you may use the binding: circuits_gpio:. For example: circuits_gpio:open(5, output).","ref":"readme.html#faq","title":"Elixir Circuits - GPIO - FAQ","type":"extras"},{"doc":"Porting Elixir/ALE to Circuits.GPIOThe Circuits.GPIO package is the next version of Elixir/ALE's GPIO support. If you're currently using Elixir/ALE, you're encouraged to switch. Here are some benefits:Supported by both the maintainer of Elixir/ALE and a couple others. They'd prefer to support Circuits.GPIO issues.Much faster than Elixir/ALE - like it's not even close. The guideline is still to use GPIOs for buttons, LEDs, and other low frequency devices and use specialized device drivers for the rest. However, we know that's not always easy and the extra performance is really nice to have.Included pull up/pull down support for Raspberry Pi. We'd like to include this for other platforms as well. This was the single-most requested feature for Elixir/ALE.Timestamped interrupt reports - This is makes it possible to measure time deltas between GPIO changes with higher accuracy by removing variability from messages sitting in queues and passing between processesInterrupt glitch detection - When the GPIO toggles faster than Circuits.GPIO can handle, it can either synthesize an interrupt event or suppress the event.Lower resource usage - Elixir/ALE created a GenServer and OS process for each GPIO. Circuits.GPIO creates a NIF resource (Elixir Reference) for each GPIO.Circuits.GPIO uses Erlang's NIF interface. NIFs have the downside of being able to crash the Erlang VM. Experience with Elixir/ALE has given many of us confidence that this won't be a problem.","ref":"porting.html","title":"Porting Elixir/ALE to Circuits.GPIO","type":"extras"},{"doc":"Circuits.GPIO is not a GenServer, so if you've added ElixirALE.GPIO to a supervision tree, you'll have to take it out and manually call Circuits.GPIO.open to obtain a reference. A common pattern is to create a GenServer that wraps the GPIO and is descriptive of what the GPIO controls or signals. Put the Circuits.GPIO.open call in your init/1 callback.The remain modifications should mostly be mechanical:Rename references to ElixirALE.GPIO to Circuits.GPIO and elixir_ale to circuits_gpioChange calls to ElixirALE.GPIO.start_link/2 to Circuits.GPIO.open/2. While you're at it, review the arguments to open to not include any GenServer options.Change calls to ElixirALE.GPIO.set_int/2 to Circuits.GPIO.set_interrupts/3.Change the pattern match for the GPIO interrupt events to match 4 tuples. They have the form {:circuits_gpio, &lt;pin_number&gt;, &lt;timestamp&gt;, &lt;value&gt;}Review calls to write/2 to ensure that they pass 0 or 1. ElixirALE allowed users to pass true and false. That won't work. Running Dialyzer should catch this change as well.Consider adding a call to Circuits.GPIO.close/1 if there's an obvious place to release the GPIO. This is not strictly necessary since the garbage collector will free unreferenced GPIOs.If you find that you have to make any other changes, please let us know via an issue or PR so that other users can benefit.","ref":"porting.html#code-modifications","title":"Porting Elixir/ALE to Circuits.GPIO - Code modifications","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Bug fixesFix quoting issue that was causing failures on Yocto. Thanks to Zander Erasmus for this.","ref":"changelog.html#v0-4-6","title":"Changelog - v0.4.6","type":"extras"},{"doc":"Bug fixesOpening a GPIO to read its state won't clear the interrupt status of another listener. Registering for interrupts a second time will still clear out the first registree, though. That's a limitation of the interface. However, for debugging, it can be nice to look at a GPIO without affecting the program and this change allows for that.","ref":"changelog.html#v0-4-5","title":"Changelog - v0.4.5","type":"extras"},{"doc":"Bug fixesAdd -fPIC to compilation flags to fix build with nerves_system_x86_64 and other environments using the Musl C toolchains","ref":"changelog.html#v0-4-4","title":"Changelog - v0.4.4","type":"extras"},{"doc":"Bug fixesFix GPIO glitch suppression when interrupts were enabled. Glitch suppression filters out transitions on a GPIO line that are too fast for Linux and the NIF to see both the rising and falling edges. Turning it off synthesizes events. You can identify synthesized events since they have the same timestamp to the nanosecond. See Circuits.GPIO.set_interrupts/3.ImprovementIt's possible to enable the &quot;stub&quot; on Linux by setting CIRCUITS_MIX_ENV=test. This can be useful for unit testing code that uses Circuits.GPIO. Thanks to Enrico Rivarola for adding this!","ref":"changelog.html#v0-4-3","title":"Changelog - v0.4.3","type":"extras"},{"doc":"Bug fixesFix pullup/pulldown support for the Raspberry Pi 4","ref":"changelog.html#v0-4-2","title":"Changelog - v0.4.2","type":"extras"},{"doc":"Bug fixesFix a race condition on Raspbian where Circuits.GPIO would try to open the GPIO sysfs file before udev had a chance to fix its permissions.Fix RPi platform detection on Raspbian so that pull-ups/pull-downs work without passing any flags.","ref":"changelog.html#v0-4-1","title":"Changelog - v0.4.1","type":"extras"},{"doc":"The GPIO interrupt notification messages have been changed for consistency with other circuits projects. The initial element of the tuple is now :circuits_gpio, so messages will look like:{:circuits_gpio, 19, 83268239, 1}Please update your project if you call set_interrupts/2.No more backwards incompatible changes are expected until after 1.0.","ref":"changelog.html#v0-4-0","title":"Changelog - v0.4.0","type":"extras"},{"doc":"Bug fixesBuild C source under the _build directory so that changing targets properly rebuilds the C code as well as the Elixir.","ref":"changelog.html#v0-3-1","title":"Changelog - v0.3.1","type":"extras"},{"doc":"New featuresSupport pull_mode initializion in open/3.","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"New featuresAdd support for opening GPIOs to an initial value or to not change the value. This removes a glitch if you want the GPIO to start out high (the default was low) or if you want the GPIO to keep its current value.","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Initial release to hex.","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]